package com.ruoyi.web.v3.service.impl;

import cn.hutool.core.bean.BeanUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.ruoyi.common.core.domain.AjaxResult;
import com.ruoyi.web.v3.entity.HbDeviceMaintenanceDictionaryEntity;
import com.ruoyi.web.v3.mapper.HbDeviceMaintenanceDictionaryMapper;
import com.ruoyi.web.v3.model.request.HbDeviceMaintenanceDictionaryPageReq;
import com.ruoyi.web.v3.service.IHbDeviceMaintenanceDictionaryService;
import com.ruoyi.web.v3.utils.QueryWrapperBuildUtil;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.util.ObjectUtils;

import java.util.Arrays;

import static com.ruoyi.common.core.domain.AjaxResult.error;
import static com.ruoyi.common.core.domain.AjaxResult.success;

/**
 * <p>
 * v3.0 设备维护条目字典管理 服务实现类
 * </p>
 *
 */
@Service
public class HbDeviceMaintenanceDictionaryServiceImpl extends ServiceImpl<HbDeviceMaintenanceDictionaryMapper, HbDeviceMaintenanceDictionaryEntity> implements IHbDeviceMaintenanceDictionaryService {

    @Transactional
    @Override
    public AjaxResult add(HbDeviceMaintenanceDictionaryEntity request) {
        //入参检测
        if(ObjectUtils.isEmpty(request.getDeviceName())) {
            return error("请输入【设备名称】！");
        }
        if(ObjectUtils.isEmpty(request.getMaintenanceItem())) {
            return error("请输入【维护条目】！");
        }
        return success("添加成功", baseMapper.insert(request));
    }

    @Transactional
    @Override
    public AjaxResult edit(HbDeviceMaintenanceDictionaryEntity request) {
        //数据格式校验
        if(ObjectUtils.isEmpty(request.getId())){
            return error("待更新数据未传入有效ID，请设置数据的唯一标识ID！");
        }
        //根据数据的id更新所有不为空的字段
        return updateById(request) ? success("修改成功！") : error("修改失败，请重试！");
    }

    @Transactional
    @Override
    public AjaxResult delete(String ids) {
        String[] idList = ids.split(",");
        return success("删除成功", removeByIds(Arrays.asList(idList)));
    }

    @Override
    public AjaxResult page(HbDeviceMaintenanceDictionaryPageReq request) {
        //将请求报文转为实体类
        HbDeviceMaintenanceDictionaryEntity entity = BeanUtil.toBean(request, HbDeviceMaintenanceDictionaryEntity.class);
        //构造查询条件（检索条件未定时，先按不为空的字段进行等值查询）
        QueryWrapper<HbDeviceMaintenanceDictionaryEntity> wrapper = QueryWrapperBuildUtil.notNoneEqWrapperHelper(entity);
        return success(baseMapper.selectPage(request.toPage(), wrapper));
    }

    @Override
    public AjaxResult listAll() {
        return success(lambdaQuery().list());
    }
}
